Index: /gsdl/trunk/perllib/basebuilder.pm
===================================================================
--- /gsdl/trunk/perllib/basebuilder.pm	(revision 16378)
+++ /gsdl/trunk/perllib/basebuilder.pm	(revision 16379)
@@ -379,5 +379,5 @@
    
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, 
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'},0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'},0, $self->{'gli'});
 
     # this has changed to only output collection meta if its 
Index: /gsdl/trunk/perllib/lucenebuilder.pm
===================================================================
--- /gsdl/trunk/perllib/lucenebuilder.pm	(revision 16378)
+++ /gsdl/trunk/perllib/lucenebuilder.pm	(revision 16379)
@@ -173,5 +173,5 @@
 		   $self->{'buildproc'}, $self->{'maxdocs'});
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'},
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
     &plugin::end($self->{'pluginfo'});
     close ($handle) unless $self->{'debug'};
@@ -342,5 +342,5 @@
     $self->{'buildproc'}->reset();
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'},
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
     close ($handle) unless $self->{'debug'};
 
@@ -396,5 +396,5 @@
     # 3. Read in all the metadata from the files in the archives directory using
     #    the GAPlug and using ourselves as the document processor!
-    &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, "", {}, $self->{'buildproc'}, $self->{'maxdocs'},0, $self->{'gli'});
+    &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'},0, $self->{'gli'});
 
     print STDERR "</Stage>\n" if $self->{'gli'};
Index: /gsdl/trunk/perllib/mgbuilder.pm
===================================================================
--- /gsdl/trunk/perllib/mgbuilder.pm	(revision 16378)
+++ /gsdl/trunk/perllib/mgbuilder.pm	(revision 16379)
@@ -173,5 +173,5 @@
 		   $self->{'buildproc'}, $self->{'maxdocs'});
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, 
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
     &plugin::end($self->{'pluginfo'});
     
@@ -211,5 +211,5 @@
 
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, 
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
 
     close ($handle) unless $self->{'debug'};
@@ -417,5 +417,5 @@
     $self->{'buildproc'}->reset();
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, 
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'},0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'},0, $self->{'gli'});
     close ($handle) unless $self->{'debug'};
 
@@ -451,5 +451,5 @@
     $self->{'buildproc'}->reset();
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, 
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'},0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'},0, $self->{'gli'});
 
    
Index: /gsdl/trunk/perllib/mgppbuilder.pm
===================================================================
--- /gsdl/trunk/perllib/mgppbuilder.pm	(revision 16378)
+++ /gsdl/trunk/perllib/mgppbuilder.pm	(revision 16379)
@@ -253,5 +253,5 @@
 		   $self->{'buildproc'}, $self->{'maxdocs'});
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, 
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
     &plugin::end($self->{'pluginfo'});
 
@@ -293,5 +293,5 @@
 
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, 
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
     close ($handle) unless $self->{'debug'};
 
@@ -510,5 +510,5 @@
     $self->{'buildproc'}->reset();
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, 
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
     close ($handle) unless $self->{'debug'};
 
@@ -545,5 +545,5 @@
     $self->{'buildproc'}->reset();
     &plugin::read ($self->{'pluginfo'}, $self->{'source_dir'}, 
-		   "", {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
+		   "", {}, {}, $self->{'buildproc'}, $self->{'maxdocs'}, 0, $self->{'gli'});
 
     $self->print_stats ();