Index: /greenstone3/trunk/web/sites/localsite/collect/infomine/metadata.xml
===================================================================
--- /greenstone3/trunk/web/sites/localsite/collect/infomine/metadata.xml	(revision 16486)
+++ /greenstone3/trunk/web/sites/localsite/collect/infomine/metadata.xml	(revision 16486)
@@ -0,0 +1,29 @@
+<metadataList>
+
+  <metadataItem name="collectionName" lang="en">INFOMINE demo</metadataItem>
+  <metadataItem name="collectionName" lang="fr">DÃ©mo d'INFOMINE</metadataItem> 
+
+  <metadataItem name="collectionDescription" lang="en"> 
+	<p>This is a demonstration collection that acts as a proxy to the iVia database at <a href="http://infomine.ucr.edu/">INFOMINE</a>, Riverside, California. No data is stored locally; instead, the search and retrieval services invoke cgi scripts at infomine to query the database, and retrieve records and metadata.</p>
+
+	<p>A <a href="sites/localsite/collect/infomine/README">README</a> file
+    describes the cgi scripts and how to invoke them. The configuration
+    files for the collection are very basic, and merely specify display 
+    information for the collection, and specify the IViaProxy service
+    rack. The collection configuration can be seen <a href="sites/localsite/collect/infomine/etc/collectionConfig.xml">here</a>,
+    and the building configuration file can be seen <a href="sites/localsite/collect/infomine/index/buildConfig.xml">here</a>.
+       You may need to "view page source" to see the raw XML.</p></metadataItem>
+
+  <metadataItem name="collectionDescription" lang="fr"> 
+  	
+<p>Cette dÃ©monstration est une collection qui agit comme un proxy pour la base de donnÃ©es Ã  iVia <a href="http://infomine.ucr.edu/">INFOMINE</a>, Riverside, Californie. Aucune donnÃ©e n'est stockÃ©e localement, la recherche et rÃ©cupÃ©ration de donnÃ©es invoque les services d'infomine pour interroger sa base de donnÃ©es Ã  distance, afin de rÃ©cupÃ©rer des documents Ã  afficher.</p>
+
+<p>
+Un fichier README dÃ©crit les scripts cgi et comment les utiliser. Les fichiers de configuration pour la collecte de donnÃ©es sont trÃšs rudimentaires, ils affichent simplement les informations pour la collection choisie, et prÃ©cisent le service IViaProxy Ã  utiliser. La configuration de cette collection peut Ãªtre vu <a href="sites/localsite/collect/infomine/etc/collectionConfig.xml">ici</a>, et le fichier de configuration peut Ãªtre vu <a href="sites/localsite/collect/infomine/index/buildConfig.xml">ici</a>. Vous devrez peut Ãªtre cliquer sur "afficher la source de la page" pour voir le code XML brut.
+</p>
+
+  </metadataItem>
+
+
+
+</metadataList>
Index: /greenstone3/trunk/web/sites/localsite/collect/infomine/ui/css/style.css
===================================================================
--- /greenstone3/trunk/web/sites/localsite/collect/infomine/ui/css/style.css	(revision 16486)
+++ /greenstone3/trunk/web/sites/localsite/collect/infomine/ui/css/style.css	(revision 16486)
@@ -0,0 +1,13 @@
+img {
+	border: 1px solid #00CC00;
+	background-color: rgb(150,150,150);
+}
+.rightBox {
+	float: right;
+	margin: 10px;
+}
+
+.centeredBox {
+	display: table; table-layout: auto; }
+	
+
Index: /greenstone3/trunk/web/sites/localsite/collect/infomine/ui/ui.xml
===================================================================
--- /greenstone3/trunk/web/sites/localsite/collect/infomine/ui/ui.xml	(revision 16486)
+++ /greenstone3/trunk/web/sites/localsite/collect/infomine/ui/ui.xml	(revision 16486)
@@ -0,0 +1,84 @@
+<ui xmlns:gsf="http://www.greenstone.org/greenstone3/schema/UI" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+
+  <skin name="oran" inherit="false" local="false"/>
+
+  <uiItemList>
+
+    <uiItem name="collectionHeader" inherit="true" />
+    <uiItem name="collectionFooter" inherit="true" />
+    <uiItem name="collectionTitle" inherit="true" />
+
+
+    <uiItem name="collectionAbout" lang="en" inherit="false">
+	  <h1> About this collection </h1>
+	  <p>
+        <metadataItem name="collectionDescription" /> 
+      </p>
+	  
+
+      <h1> About INFOMINE </h1>
+      <div class="rightBox">
+       <img src="./sites/localsite/collect/infomine/ui/img/infomine.gif" width="311" height="67"> </img>
+      </div> 
+
+      <p>
+	<a href="http://infomine.ucr.edu/">INFOMINE</a> is a virtual library of Internet resources relevant to faculty, students, and research staff at the university level. It contains useful Internet resources such as databases, electronic journals, electronic books, bulletin boards, mailing lists, online library card catalogs, articles, directories of researchers, and many other types of information.
+      </p>
+	  
+	  <p>
+	  INFOMINE is librarian built. Librarians from the University of California, Wake Forest University, California State University, the University of Detroit - Mercy, and other universities and colleges have contributed to building INFOMINE.
+	  </p>
+	  
+	  
+    </uiItem>
+     
+	 
+	 
+	 
+    <uiItem name="collectionAbout" lang="fr" inherit="false">
+	<h1> A propos de cette collection </h1>
+	<p>
+        <metadataItem name="collectionDescription" /> 
+      </p>
+
+      <h1> Ã propos d'INFOMINE </h1>
+      <div class="rightBox">
+       <img src="./sites/localsite/collect/infomine/ui/img/infomine.gif" width="311" height="67"> </img>
+      </div> 
+	  
+      <p>
+	<a href="http://infomine.ucr.edu/">INFOMINE</a> est une bibliothÃšque virtuelle de ressources Internet en rapport avec les enseignants, les Ã©tudiants et le personnel de recherche au niveau universitaire. INFOMINE contient des docuemnts tels que des bases de donnÃ©es, revues Ã©lectroniques, livres Ã©lectroniques, des forums Ã©lectroniques, listes de diffusion, catalogues de bibliothÃšque en ligne, des articles, des publications de recherche, et de nombreux autres types d'informations.
+      </p>
+	  
+	  <p>
+	  INFOMINE est construit par des bibliothÃ©caires. Les bibliothÃ©caires de l'UniversitÃ© de Californie, de Wake Forest University, de California State University, de l'UniversitÃ© de Detroit - Mercy, et d'autres Ã©tablissements ont contribuÃ© Ã  l'Ã©dification INFOMINE.
+	  </p>
+	  
+    </uiItem>
+
+
+
+  </uiItemList>
+
+
+
+  <serviceFormatList>
+
+    <serviceFormat name="search">
+
+      <gsf:template match="documentNode">
+        <td valign="top"> <gsf:link> <gsf:icon/> </gsf:link> </td>
+	<td> <table>
+	  <tr> <td> <a> 
+	    <xsl:attribute name="href"> <gsf:metadata name="url"/> </xsl:attribute> 
+	    <b> <gsf:metadata name="title" /> </b> 
+	  </a> </td> </tr>
+	  <tr> <td> <gsf:metadata name="ivia_description" /> </td> </tr>
+	  <tr> <td> <b> <gsf:metadata name="url" /> </b> </td> </tr>
+	  <tr> <td> [ <gsf:link>View Full Record</gsf:link> ] </td> </tr>
+  	</table> </td>
+      </gsf:template>
+
+   </serviceFormat>
+  </serviceFormatList>
+</ui>