Index: greenstone3/trunk/web/sites/localsite/collect/gs2mgppdemo/metadata.xml
===================================================================
--- greenstone3/trunk/web/sites/localsite/collect/gs2mgppdemo/metadata.xml	(revision 16488)
+++ greenstone3/trunk/web/sites/localsite/collect/gs2mgppdemo/metadata.xml	(revision 16488)
@@ -0,0 +1,17 @@
+<metadataList>
+
+  <metadataItem name="collectionName" lang="en">Greenstone2 MGPP demo</metadataItem>
+  <metadataItem name="collectionName" lang="fr">DÃ©mo de Greenstone2 avec MGPP</metadataItem> 
+
+  <metadataItem name="collectionDescription" lang="en"> 
+	This is a demonstration collection for the Greenstone3 digital library software. It contains a small subset (<metadataItem name="collectionDocuments" /> books) of the Humanitarian and Development Libraries. It is a Greenstone2 collection, built with MGPP. The Greenstone2 configuration files have been converted to Greenstone3 equivalents, enabling it to be served using Greenstone3.
+  </metadataItem>
+
+  <metadataItem name="collectionDescription" lang="fr"> 
+  Ceci est une collection de dÃ©monstration pour le logiciel de bibliothÃšque numÃ©rique Greenstone 3. Elle ne contient qu'une fraction (<metadataItem name="collectionDocuments" /> livres) des BibliothÃšques Humanitaires pour le DÃ©veloppement. Il s'agit d'une collection pour Greenstone 2, crÃ©Ã©e avec le moteur de recherche avancÃ© de Greenstone (appelÃ© mgpp). Les fichiers de configuration de Greenstone 2 ont Ã©tÃ©s convertis vers des Ã©quivalents pour Greenstone 3, afin que cette collection puisse Ãªtre diffusÃ©e Ã  partir d'un serveur utilisant Greenstone 3.
+  </metadataItem>
+
+  <metadataItem name="collectionDocuments">11</metadataItem>
+
+
+</metadataList>
Index: greenstone3/trunk/web/sites/localsite/collect/gs2mgppdemo/ui/css/style.css
===================================================================
--- greenstone3/trunk/web/sites/localsite/collect/gs2mgppdemo/ui/css/style.css	(revision 16488)
+++ greenstone3/trunk/web/sites/localsite/collect/gs2mgppdemo/ui/css/style.css	(revision 16488)
@@ -0,0 +1,13 @@
+img {
+	border: 1px solid #00CC00;
+	background-color: rgb(150,150,150);
+}
+.rightBox {
+	float: right;
+	margin: 10px;
+}
+
+.centeredBox {
+	display: table; table-layout: auto; }
+	
+
Index: greenstone3/trunk/web/sites/localsite/collect/gs2mgppdemo/ui/ui.xml
===================================================================
--- greenstone3/trunk/web/sites/localsite/collect/gs2mgppdemo/ui/ui.xml	(revision 16488)
+++ greenstone3/trunk/web/sites/localsite/collect/gs2mgppdemo/ui/ui.xml	(revision 16488)
@@ -0,0 +1,88 @@
+<ui xmlns:gsf="http://www.greenstone.org/greenstone3/schema/UI" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+
+  <skin name="oran" inherit="false" local="false"/>
+
+  <uiItemList>
+
+    <uiItem name="collectionHeader" inherit="true" />
+    <uiItem name="collectionFooter" inherit="true" />
+    <uiItem name="collectionTitle" inherit="true" />
+
+
+    <uiItem name="collectionAbout" lang="en" inherit="false">
+	  <h1> About this collection </h1>
+	  <p>
+        <metadataItem name="collectionDescription" /> 
+      </p>
+	  
+
+      <h1> About The Humanity Development Collection </h1>
+      <div class="rightBox">
+       <img src="./sites/localsite/collect/gs2mgdemo/ui/img/hdl.gif" width="300" height="77"> </img>
+      </div> 
+
+      <p>
+	The <a href="http://www.nzdl.org/">Humanity Development Library</a> is a large collection of practical information aimed at helping reduce poverty, increasing human potential, and providing a practical and useful education for all. This version, 2.0, contains 1,230 publications--books, reports, and magazines--in various areas of human development, from agricultural practice to economic policies, from water and sanitation to society and culture, from education to manufacturing, from disaster mitigation to micro-enterprises. It contains a total of 160,000 pages and 30,000 images, which if printed would weigh 340 kg and cost US$20,000. It is available on CD-ROM at US$2 for distribution in developing countries.
+      </p>
+	  
+	  <p>
+	  The objective of the Humanity Libraries Project is to provide all involved in development, well-being and basic needs with access to a complete library of around 3,000 multidisciplinary books containing practical knowhow and ideas. We invite many more development organizations to share their useful publications, to help distribute these libraries, and to participate in this humanitarian project. 
+	  </p>
+	  
+	  <p>
+	  The editors of this collection are Human Info NGO, HumanityCD Ltd,
+and Participating Organizations. Contact us at Humanities Libraries Project,
+Oosterveldiaan 196, B-2610 Antwerp, Belgium, Tel 32-3-448.05.54, Fax 32-3-449.75.74, email <a href="mailto:humanity@humaninfo.org">humanity@humaninfo.org</a>.
+	  </p>
+	  
+    </uiItem>
+     
+	 
+	 
+	 
+    <uiItem name="collectionAbout" lang="fr" inherit="false">
+	<h1> A propos de cette collection </h1>
+	<p>
+        <metadataItem name="collectionDescription" /> 
+      </p>
+
+      <h1> Ã propos des BibliothÃšques humanitaires pour le DÃ©veloppement </h1>
+      <div class="rightBox">
+       <img src="./sites/localsite/collect/gs2mgdemo/ui/img/hdl.gif" width="300" height="77"> </img>
+      </div> 
+	  
+	  <p>
+Les <a href="http://88.191.12.135/cgi-bin/library">BibliothÃšques humanitaires pour le DÃ©veloppement</a> constituent une collection importante dont les objectifs sont d'aider Ã  rÃ©duire la pauvretÃ©, de promouvoir l'accroissement du potentiel humain, et d'offrir une Ã©ducation pratique et utile Ã  tous. Cette collection contient environ 25 publications -- documents, rapports, et articles de pÃ©riodiques -- qui traitent de diffÃ©rents sujets liÃ©s au dÃ©veloppement humain. On y trouve des informations concernant les pratiques agricoles aussi bien que les politiques Ã©conomiques; les mesures d'hygiÃšne pour l'eau et la sociÃ©tÃ© et la culture; l'Ã©ducation et la petite industrie; la prÃ©vention des dÃ©sastres et les micro-entreprises.
+	  </p>
+	  
+	  <p>
+Les Ã©diteurs  de cette collection sont Human Info NGO, HumanityCD Ltd, and organisations  ayant contribuÃ©. Vous pouvez nous contacter Ã  Humanitarian and Development  Libraries Project, Oosterveldiaan 196, B-2610 Antwerp, Belgium, Tel  32-3-448.05.54, Fax 32-3-449.75.74, courriel <a href="mailto:humanity@humaninfo.org">humanity@humaninfo.org</a>.
+	  </p>
+    </uiItem>
+
+
+
+  </uiItemList>
+
+
+
+  <serviceFormatList>
+
+    <serviceFormat name="search">
+
+      <gsf:template match="documentNode">
+        <td valign="top"> <gsf:link> <gsf:icon/> </gsf:link> </td>
+	<td> <table>
+	  <tr> <td> <a> 
+	    <xsl:attribute name="href"> <gsf:metadata name="url"/> </xsl:attribute> 
+	    <b> <gsf:metadata name="title" /> </b> 
+	  </a> </td> </tr>
+	  <tr> <td> <gsf:metadata name="ivia_description" /> </td> </tr>
+	  <tr> <td> <b> <gsf:metadata name="url" /> </b> </td> </tr>
+	  <tr> <td> [ <gsf:link>View Full Record</gsf:link> ] </td> </tr>
+  	</table> </td>
+      </gsf:template>
+
+   </serviceFormat>
+  </serviceFormatList>
+</ui>