Index: /greenstone3/trunk/web/sites/localsite/collect/gberg/metadata.xml
===================================================================
--- /greenstone3/trunk/web/sites/localsite/collect/gberg/metadata.xml	(revision 16491)
+++ /greenstone3/trunk/web/sites/localsite/collect/gberg/metadata.xml	(revision 16491)
@@ -0,0 +1,29 @@
+<metadataList>
+
+  <metadataItem name="collectionName" lang="en">Sample XML demo</metadataItem>
+  <metadataItem name="collectionName" lang="fr">Collections en XML dÃ©mo</metadataItem> 
+
+  <metadataItem name="collectionDescription" lang="en"> 
+<p>This collection is designed to demonstrate some of the flexibility of the Greenstone 3 architecture. Collections are not restricted to those built using the standard building process, but rather can be anything you want, as long as suitable services are provided.</p> 
+
+<p> This collection contains 4 documents obtained from the <a href="http://gutenberg.net/">Gutenberg project</a>. Project Gutenberg documents are marked up in XML, and come with DTDs and CSS stylesheets. The collection has not been built using either Greenstone2 or Greenstone3 style building. Instead, simple java programs using the Lucene API have been created to do the indexing, and document retrieval is simply done from the original (actually slightly modified) XML documents. A description of the building process can be found in the <a href="sites/localsite/collect/gberg/README">README</a> file for this collection.</p> 
+<p> This collection has a different appearance to standard collections, accomplished through the use of custom XSLT files, found in the transform directory of the collection. The 'about' page for the collection shows a list of all the documents. This is achieved by using a new about.xsl file. Document display is quite different for this collection: the display can be either table of contents style, or text style. Two new xslts were written to handle the two display types. A new document action also had to be created (XMLDocumentAction), and the interface config file was altered to map the xd action code to this new Action class.</p> 
+<p> <textarea rows="5" cols="60" readonly="readonly">  
+ &lt;action name='xd' class='XMLDocumentAction'&gt;<br />
+ &lt;subaction name='toc' xslt='document-toc.xsl'/&gt;<br />
+ &lt;subaction name='text' xslt='document-text.xsl'/&gt;<br />
+ &lt;/action&gt; </textarea> 
+
+</p> 
+<p>The collection uses a generic Greenstone Lucene search service, and a specific retrieval service class, GutBookRetrieve. This extends the generic XMLRetrieve serviceRack to handle metadata extraction for the Gutenberg documents.</p> 
+<p>The collection configuration file can be seen <a href="sites/localsite/collect/gberg/etc/collectionConfig.xml">here</a>, and the building configuration file can be seen <a href="sites/localsite/collect/gberg/index/buildConfig.xml">here</a>.</p>	
+</metadataItem>
+
+  <metadataItem name="collectionDescription" lang="fr"> 
+  	
+
+  </metadataItem>
+
+
+
+</metadataList>
Index: /greenstone3/trunk/web/sites/localsite/collect/gberg/ui/ui.xml
===================================================================
--- /greenstone3/trunk/web/sites/localsite/collect/gberg/ui/ui.xml	(revision 16491)
+++ /greenstone3/trunk/web/sites/localsite/collect/gberg/ui/ui.xml	(revision 16491)
@@ -0,0 +1,55 @@
+<ui xmlns:gsf="http://www.greenstone.org/greenstone3/schema/UI" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+
+  <skin name="oran" inherit="false" local="false"/>
+
+  <uiItemList>
+
+    <uiItem name="collectionHeader" inherit="true" />
+    <uiItem name="collectionFooter" inherit="true" />
+    <uiItem name="collectionTitle" inherit="true" />
+
+
+    <uiItem name="collectionAbout" lang="en" inherit="false">
+	  <h1> About this collection </h1>
+	  <p>
+        <metadataItem name="collectionDescription" /> 
+      </p>
+	 	  
+    </uiItem>
+     
+	 
+	 
+	 
+    <uiItem name="collectionAbout" lang="fr" inherit="false">
+	<h1> A propos de cette collection </h1>
+	<p>
+        <metadataItem name="collectionDescription" /> 
+      </p>
+    </uiItem>
+
+
+
+  </uiItemList>
+
+
+
+  <serviceFormatList>
+
+    <serviceFormat name="search">
+
+      <gsf:template match="documentNode">
+        <td valign="top"> <gsf:link> <gsf:icon/> </gsf:link> </td>
+	<td> <table>
+	  <tr> <td> <a> 
+	    <xsl:attribute name="href"> <gsf:metadata name="url"/> </xsl:attribute> 
+	    <b> <gsf:metadata name="title" /> </b> 
+	  </a> </td> </tr>
+	  <tr> <td> <gsf:metadata name="ivia_description" /> </td> </tr>
+	  <tr> <td> <b> <gsf:metadata name="url" /> </b> </td> </tr>
+	  <tr> <td> [ <gsf:link>View Full Record</gsf:link> ] </td> </tr>
+  	</table> </td>
+      </gsf:template>
+
+   </serviceFormat>
+  </serviceFormatList>
+</ui>